VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "ActiveX"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "MediaInfo ActiveX Wrapper"
Option Explicit

' A simple ActiveX wrapper for the MediaInfo DLL.
'
' Use at own risk, under the same license as MediaInfo itself.
'
' Ingo Brckl, June 2005

Public Enum stream_t
  Stream_General
  Stream_Video
  Stream_Audio
  Stream_Text
  Stream_Chapters
  Stream_Image
  Stream_Max
End Enum

Public Enum info_t
  Info_Name
  Info_Text
  Info_Measure
  Info_Options
  Info_Name_Text
  Info_Measure_Text
  Info_Info
  Info_HowTo
  Info_Max
End Enum

Public Enum infooptions_t
  InfoOption_ShowInInform
  InfoOption_Support
  InfoOption_ShowInSupported
  InfoOption_TypeOfValue
  InfoOption_Max
End Enum

Public Enum informoptions_t
  InformOption_Nothing
  InformOption_Custom
  InformOption_HTML
  InformOption_Max
End Enum

Public Sub MediaInfo_Close(ByVal Handle As Long)
Attribute MediaInfo_Close.VB_Description = "Close a file opened before with Open() (without saving)"

  Call MediaInfoDLL.MediaInfo_Close(Handle)

End Sub

Public Function MediaInfo_Count_Get(ByVal Handle As Long, ByVal StreamKind As stream_t, ByVal StreamNumber As Long) As Long
Attribute MediaInfo_Count_Get.VB_Description = "Count of streams of a stream kind (StreamNumber not filled), or count of piece of information in this stream"

  MediaInfo_Count_Get = MediaInfoDLL.MediaInfo_Count_Get(Handle, StreamKind, StreamNumber)

End Function

Public Function MediaInfo_Get(ByVal Handle As Long, ByVal StreamKind As stream_t, ByVal StreamNumber As Long, Parameter As String, ByVal InfoKind As info_t, ByVal SearchKind As info_t) As String
Attribute MediaInfo_Get.VB_Description = "Get a piece of information about a file (parameter is a string)"

  MediaInfo_Get = bstr(MediaInfoDLL.MediaInfo_Get(Handle, StreamKind, StreamNumber, StrPtr(Parameter), InfoKind, SearchKind))

End Function

Public Function MediaInfo_GetI(ByVal Handle As Long, ByVal StreamKind As stream_t, ByVal StreamNumber As Long, ByVal Parameter As Long, ByVal InfoKind As info_t) As String
Attribute MediaInfo_GetI.VB_Description = "Get a piece of information about a file (parameter is an integer)"

  MediaInfo_GetI = bstr(MediaInfoDLL.MediaInfo_GetI(Handle, StreamKind, StreamNumber, Parameter, InfoKind))

End Function

Public Function MediaInfo_Inform(ByVal Handle As Long, ByVal Options As informoptions_t) As String
Attribute MediaInfo_Inform.VB_Description = "Get all details about a file in one string"

  MediaInfo_Inform = bstr(MediaInfoDLL.MediaInfo_Inform(Handle, Options))

End Function

Public Function MediaInfo_Open(File As String) As Long
Attribute MediaInfo_Open.VB_Description = "Open a file and collect information about it (technical information and tags)"

  MediaInfo_Open = MediaInfoDLL.MediaInfo_Open(StrPtr(File))

End Function

Public Function MediaInfo_Open_Buffer(Begin As Long, ByVal Begin_Size As Long, End_ As Long, ByVal End_Size As Long) As Long
Attribute MediaInfo_Open_Buffer.VB_Description = "Open a stream (begin and end of the stream) and collect information about it (technical information and tags)"

  MediaInfo_Open_Buffer = MediaInfoDLL.MediaInfo_Open_Buffer(ByVal Begin, Begin_Size, ByVal End_, End_Size)

End Function

Public Function MediaInfo_Option(ByVal Handle As Long, Option_ As String, Value As String) As String
Attribute MediaInfo_Option.VB_Description = "Configure or get information about MediaInfoLib"

  MediaInfo_Option = bstr(MediaInfoDLL.MediaInfo_Option(Handle, StrPtr(Option_), StrPtr(Value)))

End Function

Public Function MediaInfo_Save(ByVal Handle As Long) As Long
Attribute MediaInfo_Save.VB_Description = "Save the file opened before with Open() (modifications of tags)"

  MediaInfo_Save = MediaInfoDLL.MediaInfo_Save(Handle)

End Function

Public Function MediaInfo_Set(ByVal Handle As Long, ToSet As String, ByVal StreamKind As stream_t, ByVal StreamNumber As Long, Parameter As String, OldParameter As String) As Long
Attribute MediaInfo_Set.VB_Description = "Set a piece of information about a file (parameter is a string)"

  MediaInfo_Set = MediaInfoDLL.MediaInfo_Set(Handle, StrPtr(ToSet), StreamKind, StreamNumber, StrPtr(Parameter), StrPtr(OldParameter))

End Function

Public Function MediaInfo_SetI(ByVal Handle As Long, ToSet As String, ByVal StreamKind As stream_t, ByVal StreamNumber As Long, ByVal Parameter As Long, OldParameter As String) As Long
Attribute MediaInfo_SetI.VB_Description = "Set a piece of information about a file (parameter is an integer)"

  MediaInfo_SetI = MediaInfoDLL.MediaInfo_SetI(Handle, StrPtr(ToSet), StreamKind, StreamNumber, Parameter, StrPtr(OldParameter))

End Function

Public Function MediaInfo_State_Get(ByVal Handle As Long) As Long
Attribute MediaInfo_State_Get.VB_Description = "Get the state of the library"

  MediaInfo_State_Get = MediaInfoDLL.MediaInfo_State_Get(Handle)

End Function
